#ifndef __RRGTOFACONVERTER_H__
#define __RRGTOFACONVERTER_H__

#include <grammar/Regular/RightRegularGrammar.h>
#include <automaton/FSM/FSM.h>

#include "../../interface/IConversionFSM.h"

namespace conversions
{

/**
 * Converts left regular grammar to finite automata.
 * Source: Melichar 2.98
 */
class RRGtoFAConverter : public IConversionFSM
{
public:
    /**
     * @param grammar Source right regular grammar.
     */
    RRGtoFAConverter( const grammar::RightRegularGrammar & grammar );

    ~RRGtoFAConverter( void );

    /**
     * Performs conversion.
     * @return FSM equivalent to source grammar.
     */
    automaton::FSM convert( void );

private:
    /**
     * input grammar
     */
    const grammar::RightRegularGrammar & m_grammar;
};

} /* namespace conversions */

#endif /* __RRGTOFACONVERTER_H__ */
